Summary: A Z80 cross compiler
Name: z88dk
Version: 1.9
Release: 2%{?dist}
License: Artistic clarified
Group: Development/Tools
Source: http://downloads.sourceforge.net/z88dk/z88dk-src-%{version}.tgz
Patch0: z88dk-1.8-makefile-usr-share.patch
Patch1: z88dk-1.8-makefile-fixes.patch
Patch2: z88dk-1.9-64bit.patch
Patch3: z88dk-1.8-getline-name-conflict.patch
URL: http://z88dk.sourceforge.net/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
z88dk is a Z80 cross compiler capable of generating binary files for a variety
of Z80 based machines (such as the ZX81, Spectrum, Jupiter Ace and some TI
calculators).

%prep
%setup -q -n z88dk
# Put files in %{_datadir}/z88dk rather than /usr/lib/z88dk
# Also support DESTDIR in install-libs
%patch0 -p1
# Lots of buggy makefiles there
%patch1 -p1
# 64-bit fixes
%patch2 -p1
# Fix name conflict with the getline function in POSIX 2008
%patch3 -p1
%{_bindir}/find . -depth -name CVS -type d -exec %{__rm} -rf {} \;
# Separate manpages from other docs and fix their permissions
%{__mv} doc/netman .
%{__chmod} 644 netman/man3z/*
# Fix files with wrong line endings and bad permissions
/usr/bin/find doc examples src -type f -exec %{__sed} -i -e 's/\r*$//' {} \;
/usr/bin/find doc examples src -type f -exec %{__chmod} 644 {} \;

%build
export Z80_OZFILES=%{_builddir}/z88dk/lib/
export ZCCCFG=%{_builddir}/z88dk/lib/config/
export PATH=%{_builddir}/z88dk/bin:$PATH
export CC=gcc
export CFLAGS="%{optflags}"
# Note: do not use %{?_smp_mflags} with make because the Makefiles don't support parallel builds
%{__make} clean
%{__make} -e
# libs are target libraries, they won't build with host CFLAGS
unset CFLAGS
export CFLAGS
%{__make} -e libs

%install
export Z80_OZFILES=%{_datadir}/z88dk-%{version}/lib/
export ZCCCFG=%{_datadir}/z88dk-%{version}/lib/config/
%{__rm} -rf %{buildroot}
%{__mkdir} %{buildroot}
%{__make} install install-libs DESTDIR=%{buildroot}
%{__mkdir_p} %{buildroot}%{_mandir}/man3z
%{__cp} -p netman/man3z/* %{buildroot}%{_mandir}/man3z

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(-,root,root,0755)
%doc doc/*.html doc/*.gif doc/copt.man
%doc doc/compile.txt doc/cpc.txt doc/embedded.txt doc/error.txt doc/farmods.txt
%doc doc/fileio.txt doc/lib3d.txt doc/options.txt doc/packages.txt
%doc doc/platforms.txt doc/retarget.txt doc/stdio.txt doc/ti.txt doc/z80asm.txt
%doc doc/zxscrdrv.txt
%doc EXTENSIONS LICENSE
# Examples might be worth putting in subpackage
%doc examples
%{_bindir}/appmake
%{_bindir}/copt
%{_bindir}/sccz80
%{_bindir}/z*
%{_datadir}/z88dk/
%{_mandir}/man3z/

%changelog
* Mon Jul 27 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.9-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Jul 21 2009 Kevin Kofler <Kevin@tigcc.ticalc.org> - 1.9-1
- update to 1.9 (#512391)
- update 64bit patch (one issue fixed upstream, many left)

* Fri Apr 10 2009 Kevin Kofler <Kevin@tigcc.ticalc.org> - 1.8-3
- fix name conflict with the getline function in POSIX 2008

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Mon Mar 10 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> - 1.8-1
- update to 1.8
- update makefile-fixes patch (most issues fixed upstream, only one left)
- update z88make.patch and rename to z88dk-1.8-makefile-usr-share.patch
- remove redundant sed (already covered by above patch)
- use DESTDIR instead of makeinstall macro (fixes buildroot in .cfg files)

* Sat Feb 9 2008 Kevin Kofler <Kevin@tigcc.ticalc.org> - 1.7-3
- rebuild for GCC 4.3

* Fri Dec 7 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> - 1.7-2
- patch for 64-bit issues (#185511)
- drop ExcludeArch for 64-bit architectures (#185511)

* Thu Dec 6 2007 Kevin Kofler <Kevin@tigcc.ticalc.org> - 1.7-1
- update to 1.7
- use preferred SF URL
- mention TI calculators in description
- mkdir buildroot in install
- don't try to build target libs with host CFLAGS
- fix buggy makefiles leading to silently missing libraries

* Thu Sep 27 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.6-11.1
- no ppc64

* Thu Sep 27 2007 Tom "spot" Callaway <tcallawa@redhat.com> 1.6-11
- fix license tag (Artistic clarified)

* Thu Oct 5 2006 Christian Iseli <Christian.Iseli@licr.org> 1.6-10
- rebuilt for unwind info generation, broken in gcc-4.1.1-21

* Tue Sep 19 2006 Paul F. Johnson <paul@all-the-johnsons.co.uk> - 1.6-9
- rebuild
- minor spec file changes

* Thu Mar 9 2006 Paul F. Johnson <paul@all-the-johnsons.co.uk> - 1.6-8
- Added ExcludeArch for ia64

* Mon Oct 17 2005 Paul F. Johnson <paul@all-the-johnsons.co.uk> - 1.6-7
- Add ExcludeArch for x86_64 machines

* Mon Oct 17 2005 Paul Howarth <paul@city-fan.org> - 1.6-6
- Use full URL for upstream tarball location
- Don't use macros in build-time command paths (see #170506 for discussion)
- Tarball expands to directory z88dk, not z88dk-%%{version}

* Mon Oct 17 2005 Paul F. Johnson <paul@all-the-johnsons.co.uk> 1.6-5
- Modified the spec file to fix the rpmlint problems

* Wed Sep 14 2005 Paul F. Johnson <paul@all-the-johnsons.co.uk> 1.6-4
- Add diff for makefile and patch aspect to spec
- rebuilt

* Wed Sep 14 2005 Paul F. Johnson <paul@all-the-johnsons.co.uk> 1.6-3
- Fixed the spec file as it was constantly looking to /var/tmp!
- Fixed the source to point to /usr/share/z88dk for configs
- Removed `pwd` as it was causing problems

* Tue Sep 13 2005 Paul Howarth <paul@city-fan.org> - 1.6-2
- Use macros consistently
- Clean out buildroot in %%install rather than %%prep
- Include additional docs
- Tidy summary and description
- Honor %%{optflags}
- Remove CVS cruft
- Separate manpages from rest of docs
- Put target libraries, include files etc. under %%{_datadir}, not /usr/lib
- No scriptlets needed
- Fix file permissions and line endings
- Remove vendor and packager tags
- Use "Artistic" in license tag

* Tue Sep 13 2005 Paul F. Johnson <paul@all-the-johnsons.co.uk>
- Fixes to spec file

* Mon Sep 12 2005 Paul F. Johnson <paul@all-the-johnsons.co.uk>
- initial import and rpm builds
